'use strict'

const https = require('https')
const Promise = require('apemanpromise')

function _apiRequest (pathname) {
  return new Promise((resolve, reject) =>
    https.get({
      host: 'api.github.com',
      path: pathname,
      method: 'GET',
      headers: {
        'User-Agent': 'apeman CLI'
      }
    }, (res) => {
      // Continuously update stream with data
      let body = ''
      res.on('data', (d) => {
        body += d
      })
      res.on('error', (err) => {
        reject(err)
      })
      res.on('end', () => {
        let success = Number(res.statusCode) === 200
        if (!success) {
          reject(new Error('Request failed with status: ' + res.statusCode))
          return
        }

        resolve(body)
      })
    })
  )
}

module.exports = _apiRequest
